<template>
  <v-slide-y-reverse-transition v-if="variant === 'block'">
    <v-alert
      v-if="message"
      v-model="isShown"
      :class="cssClasses"
      icon="mdi-alert-circle"
      border="start"
      color="error"
      variant="tonal"
    >
      <template #title>
        <span class="text-base font-bold">
          Ошибка приложения
        </span>
      </template>

      <template #text>
        <span>{{ message }}</span>
      </template>
    </v-alert>
  </v-slide-y-reverse-transition>

  <v-snackbar
    v-else-if="variant === 'snackbar'"
    v-model="isShown"
  >
    {{ message }}

    <template #actions>
      <v-btn
        color="red"
        variant="text"
        @click="isShown = false"
      >
        ОК
      </v-btn>
    </template>
  </v-snackbar>
</template>

<script setup lang="ts">
import { ref, computed, watch } from 'vue';

type FeedbackProps = {
  type: 'error';
  message: string;
  classes?: string;
  variant?: 'block' | 'snackbar';
}

const emit = defineEmits(['close']);
const props = withDefaults(defineProps<FeedbackProps>(), {
  classes: '',
  variant: 'block',
});

const isShown = ref(true);

const cssClasses = computed(() => {
  const defaults = 'min-w-full max-w-1';

  return props.classes
    ? `${defaults} ${props.classes}`
    : defaults;
});

watch(() => props.message, message => {
  if (!message) return;
  isShown.value = true;
});

watch(isShown, isShown => {
  if (!isShown) emit('close');
});
</script>

<style>
.v-alert__prepend { margin-right: 6px !important; }
</style>